
public class aula05ex1 {
    
    private static final float b = 1.99f;
    private float c = 2.10f;
    private static int instances;

    public static int numberOfInstances() {
     //  c++; // < c so poderia ser acessada se fosse static
       return instances;
    }

    public aula05ex1() {
       instances++;   
    }
    
    public static void main (String args[]) {
        final int a = 8;

        //b=6.9; // < erro pois b nao pode ser acessada de um contexto static (main)
        //a = 1; // < erro pois a foi definida como final
     
        // cada objeto criado chama o construtor
        // que incrementa a variavel static instances
        aula05ex1 a1 = new aula05ex1();
        aula05ex1 a2 = new aula05ex1();
        aula05ex1 a3 = new aula05ex1();

        // podemos acessar um metodo static
        // de qualquer objeto ou classe
        // como a variavel instance tambem e static
        // o valor sera o mesmo pois esta relacionada a classe e nao as suas instancias
        System.out.println("inst(a1) "+ a1.numberOfInstances());
	System.out.println("inst(a2) "+ a2.numberOfInstances());
        System.out.println("inst(aula05) "+ aula05ex1.numberOfInstances());

        System.out.println("a: "+ a);
        System.out.println("b: "+ b);
    }
} 
